//  strict
import themeObj from './theme';

var prop = function prop(key) {
  return function (props) {
    return props[key];
  };
};

var fontSize = function fontSize(key) {
  return function (props) {
    return props.theme.fontSizes[key];
  };
};

var screenSize = function screenSize(key) {
  return function (props) {
    return props.theme.screenSizes[key];
  };
};

var theme = function theme(key) {
  return function (props) {
    return props.theme[key];
  };
};

export { fontSize, prop, screenSize, theme };
export default {
  fontSize: fontSize,
  prop: prop,
  screenSize: screenSize,
  theme: theme
};