//  strict

/* eslint-disable sort-keys */
import palette from './palette';
var borderRadius = '0.255rem';
var theme = {
  e2e: true,
  fontPrimary: "'IBM Plex Sans', 'Helvetica Neue', Arial, sans-serif;",
  palette: palette,
  screenSizes: {
    sm: '48rem',
    md: '62rem',
    lg: '75rem'
  },
  brandNameColor: palette.grey100,
  buttonBackgroundColor: palette.blue600,
  buttonBorderRadius: borderRadius,
  buttonColor: palette.white,
  buttonHoverColor: palette.blue800,
  cartridgeBackgroundColor: palette.blue600,
  cartridgeColor: palette.white,
  circleBadgeBackgroundColor: palette.grey400,
  circleBadgeColor: palette.white,
  circleBadgeHoverColor: palette.blue600,
  dangerColor: palette.red600,
  footerCategoryColor: palette.grey900,
  fontSizes: {
    xs: '0.625rem',
    sm: '0.875rem',
    md: '1rem',
    lg: '1.25rem',
    xl: '1.5rem'
  },
  iconColor: palette.grey400,
  iconHoverColor: palette.grey600,
  inputActiveColor: palette.blue400,
  inputBackgroundColor: palette.white,
  inputBackgroundColorDisabled: palette.grey000,
  inputBorderColor: palette.grey100,
  inputBorderRadius: borderRadius,
  inputCheckboxCheckColorDisabled: palette.grey600,
  inputCheckboxColorDisabled: palette.greyFade100,
  inputCheckedColor: palette.blue600,
  inputColor: palette.grey800,
  inputLabelColor: palette.grey600,
  inputPlaceholderColor: palette.grey400,
  linkColor: palette.blue600,
  linkHoverColor: palette.blue800,
  loaderColor: palette.blue600,
  modalBackgroundColor: palette.greyFade600,
  modalForegroundColor: palette.white,
  modalShadowColor: palette.grey100,
  modalBorderColor: palette.grey200,
  modalZIndex: 1005,
  navbarBrandZIndex: 1001,
  navbarTogglerZIndex: 1001,
  navbarDropdownContentBackgroundColor: palette.white,
  navbarDropdownContentBorderColor: palette.grey400,
  navbarDropdownContentShadowColor: palette.greyFade400,
  navbarDropdownContentShadowColor2: palette.greyFade100,
  navbarDropdownDescriptionColor: palette.grey400,
  navbarDropdownDescriptionMobileColor: palette.whiteFade400,
  navbarDropdownHeaderColor: palette.white,
  navbarDropdownTitleColor: palette.blue600,
  navbarDropdownTitleMobileColor: palette.white,
  navbarMenuBackgroundColor: palette.blue800,
  navbarMenuZIndex: 1000,
  navbarTogglerColor: palette.white,
  paginationBackgroundColor: palette.grey000,
  paginationBorderColor: palette.grey000,
  paginationColor: palette.grey600,
  paginationHoverBackgroundColor: palette.white,
  paginationHoverColor: palette.grey800,
  paginationSelectedBackgroundColor: palette.blue600,
  paginationSelectedColor: palette.white,
  panelBackgroundColor: palette.white,
  panelShadowColor: palette.greyFade100,
  searchBarBackgroundColor: palette.white,
  searchBarIconColor: palette.grey900,
  searchBarShadowColor: palette.greyFade600,
  searchBarSubmitBackgroundColor: palette.orange400,
  searchBarSubmitColor: palette.grey900,
  searchBarSubmitHoverBackgroundColor: palette.orange400,
  searchBarUnderlinedBackgroundColor: palette.transparent,
  searchBarUnderlinedBorderColor: palette.grey200,
  sectionBackgroundColor: palette.transparent,
  successColor: palette.green600,
  tableCellEvenBackgroundColor: palette.grey000,
  tableCellOddBackgroundColor: palette.white,
  tableShadowColor: palette.grey100,
  tabMenuBarColor: palette.orange400,
  tabMenuBorderColor: palette.grey100,
  textColor: palette.grey600,
  toastBackgroundColor: palette.white,
  toastBorderRadius: borderRadius,
  toastTextColor: palette.grey800,
  togglerBackgroundColor: palette.grey000,
  togglerBorderColor: palette.transparent,
  togglerColor: palette.grey400,
  togglerSelectedBackgroundColor: palette.blue600,
  togglerSelectedColor: palette.white,
  tooltipBackgroundColor: palette.grey800,
  tooltipBorderColor: palette.grey800,
  tooltipColor: palette.white,
  warningColor: palette.orange600
};
export default theme;
/* eslint-enable sort-keys */