"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.theme = exports.screenSize = exports.prop = exports.fontSize = void 0;

var _theme = _interopRequireDefault(require("./theme"));

//  strict
var prop = function prop(key) {
  return function (props) {
    return props[key];
  };
};

exports.prop = prop;

var fontSize = function fontSize(key) {
  return function (props) {
    return props.theme.fontSizes[key];
  };
};

exports.fontSize = fontSize;

var screenSize = function screenSize(key) {
  return function (props) {
    return props.theme.screenSizes[key];
  };
};

exports.screenSize = screenSize;

var theme = function theme(key) {
  return function (props) {
    return props.theme[key];
  };
};

exports.theme = theme;
var _default = {
  fontSize: fontSize,
  prop: prop,
  screenSize: screenSize,
  theme: theme
};
exports.default = _default;