"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _palette = _interopRequireDefault(require("./palette"));

//  strict

/* eslint-disable sort-keys */
var borderRadius = '0.255rem';
var theme = {
  e2e: true,
  fontPrimary: "'IBM Plex Sans', 'Helvetica Neue', Arial, sans-serif;",
  palette: _palette.default,
  screenSizes: {
    sm: '48rem',
    md: '62rem',
    lg: '75rem'
  },
  brandNameColor: _palette.default.grey100,
  buttonBackgroundColor: _palette.default.blue600,
  buttonBorderRadius: borderRadius,
  buttonColor: _palette.default.white,
  buttonHoverColor: _palette.default.blue800,
  cartridgeBackgroundColor: _palette.default.blue600,
  cartridgeColor: _palette.default.white,
  circleBadgeBackgroundColor: _palette.default.grey400,
  circleBadgeColor: _palette.default.white,
  circleBadgeHoverColor: _palette.default.blue600,
  dangerColor: _palette.default.red600,
  footerCategoryColor: _palette.default.grey900,
  fontSizes: {
    xs: '0.625rem',
    sm: '0.875rem',
    md: '1rem',
    lg: '1.25rem',
    xl: '1.5rem'
  },
  iconColor: _palette.default.grey400,
  iconHoverColor: _palette.default.grey600,
  inputActiveColor: _palette.default.blue400,
  inputBackgroundColor: _palette.default.white,
  inputBackgroundColorDisabled: _palette.default.grey000,
  inputBorderColor: _palette.default.grey100,
  inputBorderRadius: borderRadius,
  inputCheckboxCheckColorDisabled: _palette.default.grey600,
  inputCheckboxColorDisabled: _palette.default.greyFade100,
  inputCheckedColor: _palette.default.blue600,
  inputColor: _palette.default.grey800,
  inputLabelColor: _palette.default.grey600,
  inputPlaceholderColor: _palette.default.grey400,
  linkColor: _palette.default.blue600,
  linkHoverColor: _palette.default.blue800,
  loaderColor: _palette.default.blue600,
  modalBackgroundColor: _palette.default.greyFade600,
  modalForegroundColor: _palette.default.white,
  modalShadowColor: _palette.default.grey100,
  modalBorderColor: _palette.default.grey200,
  modalZIndex: 1005,
  navbarBrandZIndex: 1001,
  navbarTogglerZIndex: 1001,
  navbarDropdownContentBackgroundColor: _palette.default.white,
  navbarDropdownContentBorderColor: _palette.default.grey400,
  navbarDropdownContentShadowColor: _palette.default.greyFade400,
  navbarDropdownContentShadowColor2: _palette.default.greyFade100,
  navbarDropdownDescriptionColor: _palette.default.grey400,
  navbarDropdownDescriptionMobileColor: _palette.default.whiteFade400,
  navbarDropdownHeaderColor: _palette.default.white,
  navbarDropdownTitleColor: _palette.default.blue600,
  navbarDropdownTitleMobileColor: _palette.default.white,
  navbarMenuBackgroundColor: _palette.default.blue800,
  navbarMenuZIndex: 1000,
  navbarTogglerColor: _palette.default.white,
  paginationBackgroundColor: _palette.default.grey000,
  paginationBorderColor: _palette.default.grey000,
  paginationColor: _palette.default.grey600,
  paginationHoverBackgroundColor: _palette.default.white,
  paginationHoverColor: _palette.default.grey800,
  paginationSelectedBackgroundColor: _palette.default.blue600,
  paginationSelectedColor: _palette.default.white,
  panelBackgroundColor: _palette.default.white,
  panelShadowColor: _palette.default.greyFade100,
  searchBarBackgroundColor: _palette.default.white,
  searchBarIconColor: _palette.default.grey900,
  searchBarShadowColor: _palette.default.greyFade600,
  searchBarSubmitBackgroundColor: _palette.default.orange400,
  searchBarSubmitColor: _palette.default.grey900,
  searchBarSubmitHoverBackgroundColor: _palette.default.orange400,
  searchBarUnderlinedBackgroundColor: _palette.default.transparent,
  searchBarUnderlinedBorderColor: _palette.default.grey200,
  sectionBackgroundColor: _palette.default.transparent,
  successColor: _palette.default.green600,
  tableCellEvenBackgroundColor: _palette.default.grey000,
  tableCellOddBackgroundColor: _palette.default.white,
  tableShadowColor: _palette.default.grey100,
  tabMenuBarColor: _palette.default.orange400,
  tabMenuBorderColor: _palette.default.grey100,
  textColor: _palette.default.grey600,
  toastBackgroundColor: _palette.default.white,
  toastBorderRadius: borderRadius,
  toastTextColor: _palette.default.grey800,
  togglerBackgroundColor: _palette.default.grey000,
  togglerBorderColor: _palette.default.transparent,
  togglerColor: _palette.default.grey400,
  togglerSelectedBackgroundColor: _palette.default.blue600,
  togglerSelectedColor: _palette.default.white,
  tooltipBackgroundColor: _palette.default.grey800,
  tooltipBorderColor: _palette.default.grey800,
  tooltipColor: _palette.default.white,
  warningColor: _palette.default.orange600
};
var _default = theme;
/* eslint-enable sort-keys */

exports.default = _default;